(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: ZKOUSEC.PAS                                                    *)
(*  Obsah: zkousecka spinacu, rele, vystupu PLC apod.                      *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 18.9.2013                                             *)
(*  Pro kompilaci: viz Uses                                                *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program zkousecka_vystupu;
uses texty2, {lze nahradit jednotkou Crt (a vsechno prevest na Gotoxy, Textcolor, Clrscr apod.)}
     matyka; {jen pro zobrazeni bazovych adres portu v hexa formatu, lze vynechat}

{Mereny spinac pripojte mezi linky DTR a CTS serioveho portu (DTR slouzi jako
napajeni, CTS jako snimac) a zkuste s nim cvakat. Program sleduje stav linky
CTS a pri kazde zmene logickych urovni zaznamena a zobrazi cca 880 vzorku.
Pokud spinac pracuje spravne, mely by pri zapnuti po uvodni nule nasledovat
same jednicky, pri vypnuti naopak po jednicce same nuly. Pokud je
opotrebovany, mohou se objevit zakmity (nahodne nuly a jednicky, nez se nova
hodnota ustali). Pro bezpecnejsi a spolehlivejsi provoz doporucuji
nepripojovat merene spinace primo na port, ale pouzit pripravek s optoclenem
(viz http://mircosoft.mzf.cz/elektro/testerplc.htm).

 Rychlost vzorkovani se da zvolit na zacatku programu. Rychlejsi rezim znamena
vzorkovani maximalni moznou frekvenci (zavislou pouze na rychlosti procesoru)
a relativne pomaly vypis vysledku az kdyz je mereni hotove. Pomalejsi rezim
znamena vypis kazdeho vzorku na obrazovku hned jakmile se zmeri (to zpomaluje
docela dost, takze nejsou potreba zadne dalsi cekaci smycky; v pripade potreby
jdou samozrejme doprogramovat). Pocet vzorku zustava konstantni, takze
s pomalejsim merenim pokryjete delsi casovy interval.

 Pokud zapnuti a vypnuti nasleduji velice rychle po sobe (napr. kdyz o sebe
kontakty jen tak skrtnou), muze se stat, ze si program te druhe udalosti
nevsimne, protoze behem ni jeste zpracovaval tu prvni. V takovem pripade bude
cele zapnuti i vypnuti zaznamenano spolecne na jedne polovine obrazovky a
kontrolka aktualniho stavu bude ukazovat spatne.}

var uart_base:array[1..4] of word absolute 0:$0400; {bazove adresy portu
     ulozene v BIOSu, obvykle $3F8,$2F8,$3E8 a $2E8, neexistujici jsou nulove}
    ba:word; {bazova adresa vybraneho portu}
    i:word; {pomocne pocitadlo}
    o:char; {pro cteni klavesnice, zpocatku i pro uchovani cisla portu}
    puvodni:char; {minuly stav linky CTS}
    prubeh:array[2..879] of char; {pole pro zaznam vzorku}
    rychle:boolean; {prepinac rezimu mereni}

function CTS:char; {vraci aktualni stav linky CTS ve znakovem formatu ('0' nebo '1')}
Begin
cts:=chr((port[ba+6] shr 4) and 1+ord('0'));
End;{cts}

function ShiftPressed:boolean; assembler; {testuje stisk Shiftu}
Asm
xor AX,AX
mov SI,$0417     {SI = $0417}
mov ES,AX        {ES = 0}
mov AX,[ES:SI]   {AX = stavovy word klavesnice}
and AX,3         {dva nejnizsi bity udavaji aktualni stav shiftu, jakakoli nenulova hodnota je true}
End;{shiftpressed}

BEGIN
{vyber portu:}
cls(0); gotoxy(1,1);
writeln('Seznam dostupnych seriovych portu na tomhle pocitaci:');
for i:=1 to 4 do {porty muzou byt max. 4}
 if uart_base[i]<>0 {vypiseme jenom ty, co existuji}
   then writeln(i,') COM',i,' (bazova adresa $',preved(uart_base[i],16,3),')');
writexy(5,24,14,'(pri zadani cehokoli jineho nez cisla od 1 do 4 program skonci)');
writeln;
 repeat
 write('Vyber port, pres ktery chces merit: ');
 readln(o);
 if (o<'1')or(o>'4') then halt;
 ba:=uart_base[ord(o)-ord('0')]; {prevadime z ASCII znaku '1'..'4' na cislo 1..4}
 if ba=0 then writeln('Port COM',o,' neexistuje, vyber nektery z uvedeneho seznamu.');
 until ba<>0;
{vyber rychlosti:}
writeln; writeln;
writeln('Mozne typy mereni:');
writeln('1) Pomalejsi vzorkovani, delsi doba mereni');
writeln('2) Rychlejsi vzorkovani, kratsi doba mereni');
writexy(5,24,14,'(pri zadani cehokoli jineho nez cisla 1 nebo 2 program skonci) ');
writeln;
write('Vyber typ: ');
readln(o);
if (o<'1')or(o>'2') then halt
                    else rychle:=o='2';
port[ba+4]:=1; {zapnuti DTR - napajeni testovaci linky}
{vykresleni obrazovky:}
tkurzorvyp;
cls(0);
writexy(2,1,7,'Aktualni stav:');
writexy(54,1,14,'(konec stisknutim Shiftu)');
writexy(2,2,7,'Prubeh posledniho zapnuti:');
writexy(2,14,7,'Prubeh posledniho vypnuti:');
for i:=0 to 10 do begin
                  obarviradek(3+i,2); {prubeh zapinani je zeleny}
                  obarviradek(15+i,4); {prubeh vypinani cerveny}
                  end;
writexy(1,3,4,'0'); {vychozi stav je v opacne barve}
writexy(1,15,2,'1');
{hlavni cyklus:}
 repeat
 puvodni:=cts; {v jakem stavu jsme ted}
 if puvodni='1' then begin
                     writexy(17,1,10,'zapnuto (1)');
                     gotoxy(2,15); {sem se vypise prubeh pristiho vypnuti}
                     end
                else begin
                     writexy(17,1,12,'vypnuto (0)');
                     gotoxy(2,3); {sem se vypise prubeh pristiho zapnuti}
                     end;
  repeat until (cts<>puvodni) {cekame na zmenu stavu testovaci linky...}
               or shiftpressed; {...nebo na rucni ukonceni
                         (slo by to i pres Keypressed, ale to je dost pomale
                         a spousta vzorku by nam mohla utect)}
 if rychle then begin {rychlejsi je ulozit prubeh do pameti a vypsat ho az potom}
                for i:=2 to 879 do prubeh[i]:=cts;
                for i:=2 to 879 do write(prubeh[i]);
                end
           else for i:=2 to 879 do write(cts);
 until shiftpressed;

port[ba+4]:=0; {vypnuti DTR}

tkurzorzap; cls(0); gotoxy(1,1);
END.